//    
//   . 
//   .
#include <iostream.h>
#define TRUE 1
#define FALSE 0
typedef int Boolean;
typedef struct Leader *Lref; // :    .
typedef struct Trailer *Tref; // :    .

//   .
typedef struct Leader 
{ 
  int Key; //  .
  int Count; // .
  int Color; // .
  Boolean Flag; //    .
  Tref Trail; //   .
  Lref Next; //       .
};

//   .
typedef struct Trailer
{
  Lref Id;
  Tref Next;
};

//   .
typedef Lref TipElement; //    .
typedef struct Zveno *svqz;
typedef struct Zveno
{
  TipElement Element; //   .
  svqz Sled;
};

class Spisok
{
  private:
     Lref Head; //     .
     Lref Tail; //   
                //     .
     int MSet[256]; // , - 
                    // 0,1,2...,n.
     void Udalenie_A (svqz *, svqz *, TipElement *);
     void Dobavlenie (svqz *, svqz *, TipElement);
     void SearchGraph (int, Lref *);
  public:
     Spisok() {//   .
                Head = Tail =  new (Leader); }
     Lref GetHead() { return Head; }
     Lref GetTail() { return Tail; }
     void MakeGraph ();
     void PrintGraph ();
     void Color (Lref, int);
     void Postr (int);
};

void main ()
{
  Spisok A;
  Lref t; //    
          //    .
  int n=0; //   .

  //      .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  //       .
  //.
  t = A.GetHead(); //  .
  while (t!=A.GetTail())
    { t->Flag = TRUE; t->Color = 0;
      n++; t = (*t).Next; }
  // ------------------------------------ 
  //   MSet.
  A.Postr(n);
  cout << " : "; 
  A.Color (A.GetHead(),n);
  cout << endl;
}

void Spisok::Postr (int n)
//   MSet.
{
  for (int i=0;i<256;i++)
    MSet[i] = (i<=n)?1:0;
}

void Spisok::SearchGraph (int w, Lref *h)
//     
//  w  ,      Head.
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     Head.
  { Tail = new (Leader); (**h).Count = 0;
	 (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head  
//,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
	  cout<<"   : "; cin>>y;
	  //,      (x,y)?
	  SearchGraph (x, &p); SearchGraph (y,&q);
	  r = (*p).Trail; Res = FALSE;
	  while ((r!=NULL)&&(!Res))
		 if ((*r).Id==q) Res = TRUE;
		 else r = (*r).Next;
	  if (!Res) //  ,     .
		{ t = new (Trailer); (*t).Id = q;
		  (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; }
	  cout<<"   : "; cin>>x;
  }
}

void Spisok::PrintGraph ()
//  ,  
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
	  cout<<(*p).Key<<"("; q = (*p).Trail;
	  while (q!=NULL)
		{ cout<<(*(*q).Id).Key; q = (*q).Next; }
	  cout<<")"; p = (*p).Next; cout<<" ";
  }
}

void Spisok::Dobavlenie (svqz *L, svqz *R, TipElement elem)
//  elem  ,   L  R.
{
  svqz K = new (Zveno);

  K->Element = elem; K->Sled = NULL;
  if (*L==NULL)
	 { (*L) = K; (*R) = K; }
  else { (*R)->Sled = K; (*R) = K; }
}

void Spisok::Udalenie_A (svqz *L, svqz *R, TipElement *A)
//   ,   L  R 
//     A.
{
  svqz q;

  if ((*L)!=NULL)
   if ((*L)->Sled!=NULL)
   {
     (*A) = (*L)->Element; q = (*L);
     (*L) = (*L)->Sled; delete q;
   }
   else {
         (*A) = (*L)->Element; delete *L;
         (*L) = (*R) = NULL;
        }
}

void Spisok::Color (Lref H, int n)
//      
// ,   ,   H
//( ).
{
  svqz L;   //    .
  svqz R;   //     .
  Lref p;   //  .
  Tref t;   //  .
  Tref t1;
  int i;    //  .
  Boolean Fl;

  L = R = NULL; //   .
  Dobavlenie (&L,&R,H); H->Flag = FALSE;
  while ( L != NULL )
  {  //   ...
     Udalenie_A (&L,&R,&p);
     t = p->Trail;
     //     r->Key.
     //   ,  
     //r->Key,   MSet.
     t1 = t;
     while ( t1 != NULL )
     {  MSet[t1->Id->Color] = 0; t1 = t1->Next; }
     //   - ""   MSet.
     Fl = TRUE; i = 1;
     while ( Fl )
      if ( MSet[i] ) Fl = FALSE; else  i++;
     p->Color = i;   // !
     cout << "(" << p->Key << "," << p->Color << ") ";
     //   MSet.
     for (i=0;i<256;MSet[i++]=0);
     for (i=0;i<=n;MSet[i++]=1);
     while ( t != NULL )
     {
       if ( t->Id->Flag )
       {
          Dobavlenie (&L,&R,t->Id);
          t->Id->Flag = FALSE;
       }
       t = t->Next;
     }
  }
}
